package com.hfkj.config;

import lombok.Data;
import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.context.annotation.PropertySource;
import org.springframework.stereotype.Component;

@Component("commonSysConfig")
@ConfigurationProperties
@PropertySource("classpath:/commonConfig.properties")
@Data
public class CommonSysConfig {

    /**
     * 微信小程序appid
     */
    private String wechatMaAppid;
    /**
     * 微信小程序secret
     */
    private String wechatMaSecret;
    /**
     * 微信公众号appid
     */
    private String wechatMpAppid;
    /**
     * 微信公众号secret
     */
    private String wechatMpSecret;

    /**
     * 【惠支付】支付渠道回调地址
     */
    private String huiPayPreorderNotifyUrl;

    /**
     * 重庆中石油 请求地址
     */
    private String chongQingCnpcUrl;
    /**
     * 重庆中石油商户号
     */
    private String chongQingCnpcMerNo;
    /**
     * 重庆中石油商户秘钥
     */
    private String chongQingCnpcMerKey;
    /**
     * 重庆中石油电子券签名秘钥
     */
    private String chongQingCnpcCouponSignKey;
    /**
     * 中油优途中石油请求地址
     */
    private String pcytCnpcPostUrl;
    /**
     * 中油优途中石油商户
     */
    private String pcytCnpcMerchant;
    /**
     * 中油优途中石油密钥
     */
    private String pcytCnpcSecret;
    /**
     * 比领星请求地址
     */
    private String blxPostUrl;

    /**
     * 汇联通卡券请求地址
     */
    private String huiliantongUrl;
    private String huiliantongAppNo;
    private String huiliantongAppkey;
    private String huiliantongAppsecret;
    private String huiliantongSinopecDistributorId;
    private String huiliantongDistributorId;
    private String huiliantongSinopecUrl;

}
