package com.hfkj.dao;

import com.hfkj.entity.BsMer;
import com.hfkj.entity.BsMerExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface BsMerMapper extends BsMerMapperExt {
    @SelectProvider(type=BsMerSqlProvider.class, method="countByExample")
    long countByExample(BsMerExample example);

    @DeleteProvider(type=BsMerSqlProvider.class, method="deleteByExample")
    int deleteByExample(BsMerExample example);

    @Delete({
        "delete from bs_mer",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into bs_mer (mer_no, mer_logo, ",
        "mer_name, director_name, ",
        "director_tel, customer_service_tel, ",
        "address, `status`, ",
        "op_user_id, op_user_name, ",
        "create_time, update_time, ",
        "ext_1, ext_2, ext_3)",
        "values (#{merNo,jdbcType=VARCHAR}, #{merLogo,jdbcType=VARCHAR}, ",
        "#{merName,jdbcType=VARCHAR}, #{directorName,jdbcType=VARCHAR}, ",
        "#{directorTel,jdbcType=VARCHAR}, #{customerServiceTel,jdbcType=VARCHAR}, ",
        "#{address,jdbcType=VARCHAR}, #{status,jdbcType=INTEGER}, ",
        "#{opUserId,jdbcType=BIGINT}, #{opUserName,jdbcType=VARCHAR}, ",
        "#{createTime,jdbcType=TIMESTAMP}, #{updateTime,jdbcType=TIMESTAMP}, ",
        "#{ext1,jdbcType=VARCHAR}, #{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(BsMer record);

    @InsertProvider(type=BsMerSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(BsMer record);

    @SelectProvider(type=BsMerSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="mer_no", property="merNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="mer_logo", property="merLogo", jdbcType=JdbcType.VARCHAR),
        @Result(column="mer_name", property="merName", jdbcType=JdbcType.VARCHAR),
        @Result(column="director_name", property="directorName", jdbcType=JdbcType.VARCHAR),
        @Result(column="director_tel", property="directorTel", jdbcType=JdbcType.VARCHAR),
        @Result(column="customer_service_tel", property="customerServiceTel", jdbcType=JdbcType.VARCHAR),
        @Result(column="address", property="address", jdbcType=JdbcType.VARCHAR),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="op_user_id", property="opUserId", jdbcType=JdbcType.BIGINT),
        @Result(column="op_user_name", property="opUserName", jdbcType=JdbcType.VARCHAR),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<BsMer> selectByExample(BsMerExample example);

    @Select({
        "select",
        "id, mer_no, mer_logo, mer_name, director_name, director_tel, customer_service_tel, ",
        "address, `status`, op_user_id, op_user_name, create_time, update_time, ext_1, ",
        "ext_2, ext_3",
        "from bs_mer",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="mer_no", property="merNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="mer_logo", property="merLogo", jdbcType=JdbcType.VARCHAR),
        @Result(column="mer_name", property="merName", jdbcType=JdbcType.VARCHAR),
        @Result(column="director_name", property="directorName", jdbcType=JdbcType.VARCHAR),
        @Result(column="director_tel", property="directorTel", jdbcType=JdbcType.VARCHAR),
        @Result(column="customer_service_tel", property="customerServiceTel", jdbcType=JdbcType.VARCHAR),
        @Result(column="address", property="address", jdbcType=JdbcType.VARCHAR),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="op_user_id", property="opUserId", jdbcType=JdbcType.BIGINT),
        @Result(column="op_user_name", property="opUserName", jdbcType=JdbcType.VARCHAR),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    BsMer selectByPrimaryKey(Long id);

    @UpdateProvider(type=BsMerSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") BsMer record, @Param("example") BsMerExample example);

    @UpdateProvider(type=BsMerSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") BsMer record, @Param("example") BsMerExample example);

    @UpdateProvider(type=BsMerSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(BsMer record);

    @Update({
        "update bs_mer",
        "set mer_no = #{merNo,jdbcType=VARCHAR},",
          "mer_logo = #{merLogo,jdbcType=VARCHAR},",
          "mer_name = #{merName,jdbcType=VARCHAR},",
          "director_name = #{directorName,jdbcType=VARCHAR},",
          "director_tel = #{directorTel,jdbcType=VARCHAR},",
          "customer_service_tel = #{customerServiceTel,jdbcType=VARCHAR},",
          "address = #{address,jdbcType=VARCHAR},",
          "`status` = #{status,jdbcType=INTEGER},",
          "op_user_id = #{opUserId,jdbcType=BIGINT},",
          "op_user_name = #{opUserName,jdbcType=VARCHAR},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "update_time = #{updateTime,jdbcType=TIMESTAMP},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(BsMer record);
}