package com.hfkj.dao;

import com.hfkj.entity.BsOrderCoupon;
import com.hfkj.entity.BsOrderCouponExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface BsOrderCouponMapper extends BsOrderCouponMapperExt {
    @SelectProvider(type=BsOrderCouponSqlProvider.class, method="countByExample")
    long countByExample(BsOrderCouponExample example);

    @DeleteProvider(type=BsOrderCouponSqlProvider.class, method="deleteByExample")
    int deleteByExample(BsOrderCouponExample example);

    @Delete({
        "delete from bs_order_coupon",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into bs_order_coupon (order_no, child_order_no, ",
        "mer_id, user_id, user_phone, ",
        "goods_id, goods_name, ",
        "goods_type_id, goods_type_name, ",
        "goods_brand_id, goods_brand_name, ",
        "goods_specs_id, goods_specs_name, ",
        "goods_spesc_original_price, goods_vpd_id, ",
        "goods_vpd_key, goods_vpd_source, ",
        "goods_count, total_price, ",
        "total_deduction_price, coupon_discount_price, ",
        "integral_discount_price, pay_real_price, ",
        "pay_channel, pay_serial_no, ",
        "pay_type, `status`, ",
        "create_time, pay_time, ",
        "cancel_time, refund_time, ",
        "finish_time, update_time, ",
        "ext_1, ext_2, ext_3)",
        "values (#{orderNo,jdbcType=VARCHAR}, #{childOrderNo,jdbcType=VARCHAR}, ",
        "#{merId,jdbcType=BIGINT}, #{userId,jdbcType=BIGINT}, #{userPhone,jdbcType=VARCHAR}, ",
        "#{goodsId,jdbcType=BIGINT}, #{goodsName,jdbcType=VARCHAR}, ",
        "#{goodsTypeId,jdbcType=BIGINT}, #{goodsTypeName,jdbcType=VARCHAR}, ",
        "#{goodsBrandId,jdbcType=BIGINT}, #{goodsBrandName,jdbcType=VARCHAR}, ",
        "#{goodsSpecsId,jdbcType=BIGINT}, #{goodsSpecsName,jdbcType=VARCHAR}, ",
        "#{goodsSpescOriginalPrice,jdbcType=DECIMAL}, #{goodsVpdId,jdbcType=BIGINT}, ",
        "#{goodsVpdKey,jdbcType=VARCHAR}, #{goodsVpdSource,jdbcType=INTEGER}, ",
        "#{goodsCount,jdbcType=INTEGER}, #{totalPrice,jdbcType=DECIMAL}, ",
        "#{totalDeductionPrice,jdbcType=DECIMAL}, #{couponDiscountPrice,jdbcType=DECIMAL}, ",
        "#{integralDiscountPrice,jdbcType=DECIMAL}, #{payRealPrice,jdbcType=DECIMAL}, ",
        "#{payChannel,jdbcType=INTEGER}, #{paySerialNo,jdbcType=VARCHAR}, ",
        "#{payType,jdbcType=INTEGER}, #{status,jdbcType=INTEGER}, ",
        "#{createTime,jdbcType=TIMESTAMP}, #{payTime,jdbcType=TIMESTAMP}, ",
        "#{cancelTime,jdbcType=TIMESTAMP}, #{refundTime,jdbcType=TIMESTAMP}, ",
        "#{finishTime,jdbcType=TIMESTAMP}, #{updateTime,jdbcType=TIMESTAMP}, ",
        "#{ext1,jdbcType=VARCHAR}, #{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(BsOrderCoupon record);

    @InsertProvider(type=BsOrderCouponSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(BsOrderCoupon record);

    @SelectProvider(type=BsOrderCouponSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="order_no", property="orderNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="child_order_no", property="childOrderNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="mer_id", property="merId", jdbcType=JdbcType.BIGINT),
        @Result(column="user_id", property="userId", jdbcType=JdbcType.BIGINT),
        @Result(column="user_phone", property="userPhone", jdbcType=JdbcType.VARCHAR),
        @Result(column="goods_id", property="goodsId", jdbcType=JdbcType.BIGINT),
        @Result(column="goods_name", property="goodsName", jdbcType=JdbcType.VARCHAR),
        @Result(column="goods_type_id", property="goodsTypeId", jdbcType=JdbcType.BIGINT),
        @Result(column="goods_type_name", property="goodsTypeName", jdbcType=JdbcType.VARCHAR),
        @Result(column="goods_brand_id", property="goodsBrandId", jdbcType=JdbcType.BIGINT),
        @Result(column="goods_brand_name", property="goodsBrandName", jdbcType=JdbcType.VARCHAR),
        @Result(column="goods_specs_id", property="goodsSpecsId", jdbcType=JdbcType.BIGINT),
        @Result(column="goods_specs_name", property="goodsSpecsName", jdbcType=JdbcType.VARCHAR),
        @Result(column="goods_spesc_original_price", property="goodsSpescOriginalPrice", jdbcType=JdbcType.DECIMAL),
        @Result(column="goods_vpd_id", property="goodsVpdId", jdbcType=JdbcType.BIGINT),
        @Result(column="goods_vpd_key", property="goodsVpdKey", jdbcType=JdbcType.VARCHAR),
        @Result(column="goods_vpd_source", property="goodsVpdSource", jdbcType=JdbcType.INTEGER),
        @Result(column="goods_count", property="goodsCount", jdbcType=JdbcType.INTEGER),
        @Result(column="total_price", property="totalPrice", jdbcType=JdbcType.DECIMAL),
        @Result(column="total_deduction_price", property="totalDeductionPrice", jdbcType=JdbcType.DECIMAL),
        @Result(column="coupon_discount_price", property="couponDiscountPrice", jdbcType=JdbcType.DECIMAL),
        @Result(column="integral_discount_price", property="integralDiscountPrice", jdbcType=JdbcType.DECIMAL),
        @Result(column="pay_real_price", property="payRealPrice", jdbcType=JdbcType.DECIMAL),
        @Result(column="pay_channel", property="payChannel", jdbcType=JdbcType.INTEGER),
        @Result(column="pay_serial_no", property="paySerialNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="pay_type", property="payType", jdbcType=JdbcType.INTEGER),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="pay_time", property="payTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="cancel_time", property="cancelTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="refund_time", property="refundTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="finish_time", property="finishTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<BsOrderCoupon> selectByExample(BsOrderCouponExample example);

    @Select({
        "select",
        "id, order_no, child_order_no, mer_id, user_id, user_phone, goods_id, goods_name, ",
        "goods_type_id, goods_type_name, goods_brand_id, goods_brand_name, goods_specs_id, ",
        "goods_specs_name, goods_spesc_original_price, goods_vpd_id, goods_vpd_key, goods_vpd_source, ",
        "goods_count, total_price, total_deduction_price, coupon_discount_price, integral_discount_price, ",
        "pay_real_price, pay_channel, pay_serial_no, pay_type, `status`, create_time, ",
        "pay_time, cancel_time, refund_time, finish_time, update_time, ext_1, ext_2, ",
        "ext_3",
        "from bs_order_coupon",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="order_no", property="orderNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="child_order_no", property="childOrderNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="mer_id", property="merId", jdbcType=JdbcType.BIGINT),
        @Result(column="user_id", property="userId", jdbcType=JdbcType.BIGINT),
        @Result(column="user_phone", property="userPhone", jdbcType=JdbcType.VARCHAR),
        @Result(column="goods_id", property="goodsId", jdbcType=JdbcType.BIGINT),
        @Result(column="goods_name", property="goodsName", jdbcType=JdbcType.VARCHAR),
        @Result(column="goods_type_id", property="goodsTypeId", jdbcType=JdbcType.BIGINT),
        @Result(column="goods_type_name", property="goodsTypeName", jdbcType=JdbcType.VARCHAR),
        @Result(column="goods_brand_id", property="goodsBrandId", jdbcType=JdbcType.BIGINT),
        @Result(column="goods_brand_name", property="goodsBrandName", jdbcType=JdbcType.VARCHAR),
        @Result(column="goods_specs_id", property="goodsSpecsId", jdbcType=JdbcType.BIGINT),
        @Result(column="goods_specs_name", property="goodsSpecsName", jdbcType=JdbcType.VARCHAR),
        @Result(column="goods_spesc_original_price", property="goodsSpescOriginalPrice", jdbcType=JdbcType.DECIMAL),
        @Result(column="goods_vpd_id", property="goodsVpdId", jdbcType=JdbcType.BIGINT),
        @Result(column="goods_vpd_key", property="goodsVpdKey", jdbcType=JdbcType.VARCHAR),
        @Result(column="goods_vpd_source", property="goodsVpdSource", jdbcType=JdbcType.INTEGER),
        @Result(column="goods_count", property="goodsCount", jdbcType=JdbcType.INTEGER),
        @Result(column="total_price", property="totalPrice", jdbcType=JdbcType.DECIMAL),
        @Result(column="total_deduction_price", property="totalDeductionPrice", jdbcType=JdbcType.DECIMAL),
        @Result(column="coupon_discount_price", property="couponDiscountPrice", jdbcType=JdbcType.DECIMAL),
        @Result(column="integral_discount_price", property="integralDiscountPrice", jdbcType=JdbcType.DECIMAL),
        @Result(column="pay_real_price", property="payRealPrice", jdbcType=JdbcType.DECIMAL),
        @Result(column="pay_channel", property="payChannel", jdbcType=JdbcType.INTEGER),
        @Result(column="pay_serial_no", property="paySerialNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="pay_type", property="payType", jdbcType=JdbcType.INTEGER),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="pay_time", property="payTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="cancel_time", property="cancelTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="refund_time", property="refundTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="finish_time", property="finishTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    BsOrderCoupon selectByPrimaryKey(Long id);

    @UpdateProvider(type=BsOrderCouponSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") BsOrderCoupon record, @Param("example") BsOrderCouponExample example);

    @UpdateProvider(type=BsOrderCouponSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") BsOrderCoupon record, @Param("example") BsOrderCouponExample example);

    @UpdateProvider(type=BsOrderCouponSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(BsOrderCoupon record);

    @Update({
        "update bs_order_coupon",
        "set order_no = #{orderNo,jdbcType=VARCHAR},",
          "child_order_no = #{childOrderNo,jdbcType=VARCHAR},",
          "mer_id = #{merId,jdbcType=BIGINT},",
          "user_id = #{userId,jdbcType=BIGINT},",
          "user_phone = #{userPhone,jdbcType=VARCHAR},",
          "goods_id = #{goodsId,jdbcType=BIGINT},",
          "goods_name = #{goodsName,jdbcType=VARCHAR},",
          "goods_type_id = #{goodsTypeId,jdbcType=BIGINT},",
          "goods_type_name = #{goodsTypeName,jdbcType=VARCHAR},",
          "goods_brand_id = #{goodsBrandId,jdbcType=BIGINT},",
          "goods_brand_name = #{goodsBrandName,jdbcType=VARCHAR},",
          "goods_specs_id = #{goodsSpecsId,jdbcType=BIGINT},",
          "goods_specs_name = #{goodsSpecsName,jdbcType=VARCHAR},",
          "goods_spesc_original_price = #{goodsSpescOriginalPrice,jdbcType=DECIMAL},",
          "goods_vpd_id = #{goodsVpdId,jdbcType=BIGINT},",
          "goods_vpd_key = #{goodsVpdKey,jdbcType=VARCHAR},",
          "goods_vpd_source = #{goodsVpdSource,jdbcType=INTEGER},",
          "goods_count = #{goodsCount,jdbcType=INTEGER},",
          "total_price = #{totalPrice,jdbcType=DECIMAL},",
          "total_deduction_price = #{totalDeductionPrice,jdbcType=DECIMAL},",
          "coupon_discount_price = #{couponDiscountPrice,jdbcType=DECIMAL},",
          "integral_discount_price = #{integralDiscountPrice,jdbcType=DECIMAL},",
          "pay_real_price = #{payRealPrice,jdbcType=DECIMAL},",
          "pay_channel = #{payChannel,jdbcType=INTEGER},",
          "pay_serial_no = #{paySerialNo,jdbcType=VARCHAR},",
          "pay_type = #{payType,jdbcType=INTEGER},",
          "`status` = #{status,jdbcType=INTEGER},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "pay_time = #{payTime,jdbcType=TIMESTAMP},",
          "cancel_time = #{cancelTime,jdbcType=TIMESTAMP},",
          "refund_time = #{refundTime,jdbcType=TIMESTAMP},",
          "finish_time = #{finishTime,jdbcType=TIMESTAMP},",
          "update_time = #{updateTime,jdbcType=TIMESTAMP},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(BsOrderCoupon record);
}