package com.hfkj.dao;

import com.hfkj.entity.BsUserIntegralRecord;
import com.hfkj.entity.BsUserIntegralRecordExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface BsUserIntegralRecordMapper extends BsUserIntegralRecordMapperExt {
    @SelectProvider(type=BsUserIntegralRecordSqlProvider.class, method="countByExample")
    long countByExample(BsUserIntegralRecordExample example);

    @DeleteProvider(type=BsUserIntegralRecordSqlProvider.class, method="deleteByExample")
    int deleteByExample(BsUserIntegralRecordExample example);

    @Delete({
        "delete from bs_user_integral_record",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into bs_user_integral_record (user_id, `type`, ",
        "transaction_amount, before_amount, ",
        "after_amount, source_type, ",
        "source_id, source_order_no, ",
        "source_content, `status`, ",
        "create_time, op_user_type, ",
        "op_user_id, op_user_name, ",
        "op_user_phone, ext_1, ",
        "ext_2, ext_3)",
        "values (#{userId,jdbcType=BIGINT}, #{type,jdbcType=INTEGER}, ",
        "#{transactionAmount,jdbcType=BIGINT}, #{beforeAmount,jdbcType=BIGINT}, ",
        "#{afterAmount,jdbcType=BIGINT}, #{sourceType,jdbcType=INTEGER}, ",
        "#{sourceId,jdbcType=BIGINT}, #{sourceOrderNo,jdbcType=VARCHAR}, ",
        "#{sourceContent,jdbcType=VARCHAR}, #{status,jdbcType=INTEGER}, ",
        "#{createTime,jdbcType=TIMESTAMP}, #{opUserType,jdbcType=INTEGER}, ",
        "#{opUserId,jdbcType=BIGINT}, #{opUserName,jdbcType=VARCHAR}, ",
        "#{opUserPhone,jdbcType=VARCHAR}, #{ext1,jdbcType=VARCHAR}, ",
        "#{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(BsUserIntegralRecord record);

    @InsertProvider(type=BsUserIntegralRecordSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(BsUserIntegralRecord record);

    @SelectProvider(type=BsUserIntegralRecordSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="user_id", property="userId", jdbcType=JdbcType.BIGINT),
        @Result(column="type", property="type", jdbcType=JdbcType.INTEGER),
        @Result(column="transaction_amount", property="transactionAmount", jdbcType=JdbcType.BIGINT),
        @Result(column="before_amount", property="beforeAmount", jdbcType=JdbcType.BIGINT),
        @Result(column="after_amount", property="afterAmount", jdbcType=JdbcType.BIGINT),
        @Result(column="source_type", property="sourceType", jdbcType=JdbcType.INTEGER),
        @Result(column="source_id", property="sourceId", jdbcType=JdbcType.BIGINT),
        @Result(column="source_order_no", property="sourceOrderNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="source_content", property="sourceContent", jdbcType=JdbcType.VARCHAR),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="op_user_type", property="opUserType", jdbcType=JdbcType.INTEGER),
        @Result(column="op_user_id", property="opUserId", jdbcType=JdbcType.BIGINT),
        @Result(column="op_user_name", property="opUserName", jdbcType=JdbcType.VARCHAR),
        @Result(column="op_user_phone", property="opUserPhone", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<BsUserIntegralRecord> selectByExample(BsUserIntegralRecordExample example);

    @Select({
        "select",
        "id, user_id, `type`, transaction_amount, before_amount, after_amount, source_type, ",
        "source_id, source_order_no, source_content, `status`, create_time, op_user_type, ",
        "op_user_id, op_user_name, op_user_phone, ext_1, ext_2, ext_3",
        "from bs_user_integral_record",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="user_id", property="userId", jdbcType=JdbcType.BIGINT),
        @Result(column="type", property="type", jdbcType=JdbcType.INTEGER),
        @Result(column="transaction_amount", property="transactionAmount", jdbcType=JdbcType.BIGINT),
        @Result(column="before_amount", property="beforeAmount", jdbcType=JdbcType.BIGINT),
        @Result(column="after_amount", property="afterAmount", jdbcType=JdbcType.BIGINT),
        @Result(column="source_type", property="sourceType", jdbcType=JdbcType.INTEGER),
        @Result(column="source_id", property="sourceId", jdbcType=JdbcType.BIGINT),
        @Result(column="source_order_no", property="sourceOrderNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="source_content", property="sourceContent", jdbcType=JdbcType.VARCHAR),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="op_user_type", property="opUserType", jdbcType=JdbcType.INTEGER),
        @Result(column="op_user_id", property="opUserId", jdbcType=JdbcType.BIGINT),
        @Result(column="op_user_name", property="opUserName", jdbcType=JdbcType.VARCHAR),
        @Result(column="op_user_phone", property="opUserPhone", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    BsUserIntegralRecord selectByPrimaryKey(Long id);

    @UpdateProvider(type=BsUserIntegralRecordSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") BsUserIntegralRecord record, @Param("example") BsUserIntegralRecordExample example);

    @UpdateProvider(type=BsUserIntegralRecordSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") BsUserIntegralRecord record, @Param("example") BsUserIntegralRecordExample example);

    @UpdateProvider(type=BsUserIntegralRecordSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(BsUserIntegralRecord record);

    @Update({
        "update bs_user_integral_record",
        "set user_id = #{userId,jdbcType=BIGINT},",
          "`type` = #{type,jdbcType=INTEGER},",
          "transaction_amount = #{transactionAmount,jdbcType=BIGINT},",
          "before_amount = #{beforeAmount,jdbcType=BIGINT},",
          "after_amount = #{afterAmount,jdbcType=BIGINT},",
          "source_type = #{sourceType,jdbcType=INTEGER},",
          "source_id = #{sourceId,jdbcType=BIGINT},",
          "source_order_no = #{sourceOrderNo,jdbcType=VARCHAR},",
          "source_content = #{sourceContent,jdbcType=VARCHAR},",
          "`status` = #{status,jdbcType=INTEGER},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "op_user_type = #{opUserType,jdbcType=INTEGER},",
          "op_user_id = #{opUserId,jdbcType=BIGINT},",
          "op_user_name = #{opUserName,jdbcType=VARCHAR},",
          "op_user_phone = #{opUserPhone,jdbcType=VARCHAR},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(BsUserIntegralRecord record);
}