package com.hfkj.dao;

import com.hfkj.entity.BsUserIntegralRecord;
import com.hfkj.entity.BsUserIntegralRecordExample.Criteria;
import com.hfkj.entity.BsUserIntegralRecordExample.Criterion;
import com.hfkj.entity.BsUserIntegralRecordExample;
import java.util.List;
import java.util.Map;
import org.apache.ibatis.jdbc.SQL;

public class BsUserIntegralRecordSqlProvider {

    public String countByExample(BsUserIntegralRecordExample example) {
        SQL sql = new SQL();
        sql.SELECT("count(*)").FROM("bs_user_integral_record");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String deleteByExample(BsUserIntegralRecordExample example) {
        SQL sql = new SQL();
        sql.DELETE_FROM("bs_user_integral_record");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String insertSelective(BsUserIntegralRecord record) {
        SQL sql = new SQL();
        sql.INSERT_INTO("bs_user_integral_record");
        
        if (record.getUserId() != null) {
            sql.VALUES("user_id", "#{userId,jdbcType=BIGINT}");
        }
        
        if (record.getType() != null) {
            sql.VALUES("`type`", "#{type,jdbcType=INTEGER}");
        }
        
        if (record.getTransactionAmount() != null) {
            sql.VALUES("transaction_amount", "#{transactionAmount,jdbcType=BIGINT}");
        }
        
        if (record.getBeforeAmount() != null) {
            sql.VALUES("before_amount", "#{beforeAmount,jdbcType=BIGINT}");
        }
        
        if (record.getAfterAmount() != null) {
            sql.VALUES("after_amount", "#{afterAmount,jdbcType=BIGINT}");
        }
        
        if (record.getSourceType() != null) {
            sql.VALUES("source_type", "#{sourceType,jdbcType=INTEGER}");
        }
        
        if (record.getSourceId() != null) {
            sql.VALUES("source_id", "#{sourceId,jdbcType=BIGINT}");
        }
        
        if (record.getSourceOrderNo() != null) {
            sql.VALUES("source_order_no", "#{sourceOrderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getSourceContent() != null) {
            sql.VALUES("source_content", "#{sourceContent,jdbcType=VARCHAR}");
        }
        
        if (record.getStatus() != null) {
            sql.VALUES("`status`", "#{status,jdbcType=INTEGER}");
        }
        
        if (record.getCreateTime() != null) {
            sql.VALUES("create_time", "#{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getOpUserType() != null) {
            sql.VALUES("op_user_type", "#{opUserType,jdbcType=INTEGER}");
        }
        
        if (record.getOpUserId() != null) {
            sql.VALUES("op_user_id", "#{opUserId,jdbcType=BIGINT}");
        }
        
        if (record.getOpUserName() != null) {
            sql.VALUES("op_user_name", "#{opUserName,jdbcType=VARCHAR}");
        }
        
        if (record.getOpUserPhone() != null) {
            sql.VALUES("op_user_phone", "#{opUserPhone,jdbcType=VARCHAR}");
        }
        
        if (record.getExt1() != null) {
            sql.VALUES("ext_1", "#{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.VALUES("ext_2", "#{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.VALUES("ext_3", "#{ext3,jdbcType=VARCHAR}");
        }
        
        return sql.toString();
    }

    public String selectByExample(BsUserIntegralRecordExample example) {
        SQL sql = new SQL();
        if (example != null && example.isDistinct()) {
            sql.SELECT_DISTINCT("id");
        } else {
            sql.SELECT("id");
        }
        sql.SELECT("user_id");
        sql.SELECT("`type`");
        sql.SELECT("transaction_amount");
        sql.SELECT("before_amount");
        sql.SELECT("after_amount");
        sql.SELECT("source_type");
        sql.SELECT("source_id");
        sql.SELECT("source_order_no");
        sql.SELECT("source_content");
        sql.SELECT("`status`");
        sql.SELECT("create_time");
        sql.SELECT("op_user_type");
        sql.SELECT("op_user_id");
        sql.SELECT("op_user_name");
        sql.SELECT("op_user_phone");
        sql.SELECT("ext_1");
        sql.SELECT("ext_2");
        sql.SELECT("ext_3");
        sql.FROM("bs_user_integral_record");
        applyWhere(sql, example, false);
        
        if (example != null && example.getOrderByClause() != null) {
            sql.ORDER_BY(example.getOrderByClause());
        }
        
        return sql.toString();
    }

    public String updateByExampleSelective(Map<String, Object> parameter) {
        BsUserIntegralRecord record = (BsUserIntegralRecord) parameter.get("record");
        BsUserIntegralRecordExample example = (BsUserIntegralRecordExample) parameter.get("example");
        
        SQL sql = new SQL();
        sql.UPDATE("bs_user_integral_record");
        
        if (record.getId() != null) {
            sql.SET("id = #{record.id,jdbcType=BIGINT}");
        }
        
        if (record.getUserId() != null) {
            sql.SET("user_id = #{record.userId,jdbcType=BIGINT}");
        }
        
        if (record.getType() != null) {
            sql.SET("`type` = #{record.type,jdbcType=INTEGER}");
        }
        
        if (record.getTransactionAmount() != null) {
            sql.SET("transaction_amount = #{record.transactionAmount,jdbcType=BIGINT}");
        }
        
        if (record.getBeforeAmount() != null) {
            sql.SET("before_amount = #{record.beforeAmount,jdbcType=BIGINT}");
        }
        
        if (record.getAfterAmount() != null) {
            sql.SET("after_amount = #{record.afterAmount,jdbcType=BIGINT}");
        }
        
        if (record.getSourceType() != null) {
            sql.SET("source_type = #{record.sourceType,jdbcType=INTEGER}");
        }
        
        if (record.getSourceId() != null) {
            sql.SET("source_id = #{record.sourceId,jdbcType=BIGINT}");
        }
        
        if (record.getSourceOrderNo() != null) {
            sql.SET("source_order_no = #{record.sourceOrderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getSourceContent() != null) {
            sql.SET("source_content = #{record.sourceContent,jdbcType=VARCHAR}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getOpUserType() != null) {
            sql.SET("op_user_type = #{record.opUserType,jdbcType=INTEGER}");
        }
        
        if (record.getOpUserId() != null) {
            sql.SET("op_user_id = #{record.opUserId,jdbcType=BIGINT}");
        }
        
        if (record.getOpUserName() != null) {
            sql.SET("op_user_name = #{record.opUserName,jdbcType=VARCHAR}");
        }
        
        if (record.getOpUserPhone() != null) {
            sql.SET("op_user_phone = #{record.opUserPhone,jdbcType=VARCHAR}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        }
        
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByExample(Map<String, Object> parameter) {
        SQL sql = new SQL();
        sql.UPDATE("bs_user_integral_record");
        
        sql.SET("id = #{record.id,jdbcType=BIGINT}");
        sql.SET("user_id = #{record.userId,jdbcType=BIGINT}");
        sql.SET("`type` = #{record.type,jdbcType=INTEGER}");
        sql.SET("transaction_amount = #{record.transactionAmount,jdbcType=BIGINT}");
        sql.SET("before_amount = #{record.beforeAmount,jdbcType=BIGINT}");
        sql.SET("after_amount = #{record.afterAmount,jdbcType=BIGINT}");
        sql.SET("source_type = #{record.sourceType,jdbcType=INTEGER}");
        sql.SET("source_id = #{record.sourceId,jdbcType=BIGINT}");
        sql.SET("source_order_no = #{record.sourceOrderNo,jdbcType=VARCHAR}");
        sql.SET("source_content = #{record.sourceContent,jdbcType=VARCHAR}");
        sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        sql.SET("op_user_type = #{record.opUserType,jdbcType=INTEGER}");
        sql.SET("op_user_id = #{record.opUserId,jdbcType=BIGINT}");
        sql.SET("op_user_name = #{record.opUserName,jdbcType=VARCHAR}");
        sql.SET("op_user_phone = #{record.opUserPhone,jdbcType=VARCHAR}");
        sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        
        BsUserIntegralRecordExample example = (BsUserIntegralRecordExample) parameter.get("example");
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByPrimaryKeySelective(BsUserIntegralRecord record) {
        SQL sql = new SQL();
        sql.UPDATE("bs_user_integral_record");
        
        if (record.getUserId() != null) {
            sql.SET("user_id = #{userId,jdbcType=BIGINT}");
        }
        
        if (record.getType() != null) {
            sql.SET("`type` = #{type,jdbcType=INTEGER}");
        }
        
        if (record.getTransactionAmount() != null) {
            sql.SET("transaction_amount = #{transactionAmount,jdbcType=BIGINT}");
        }
        
        if (record.getBeforeAmount() != null) {
            sql.SET("before_amount = #{beforeAmount,jdbcType=BIGINT}");
        }
        
        if (record.getAfterAmount() != null) {
            sql.SET("after_amount = #{afterAmount,jdbcType=BIGINT}");
        }
        
        if (record.getSourceType() != null) {
            sql.SET("source_type = #{sourceType,jdbcType=INTEGER}");
        }
        
        if (record.getSourceId() != null) {
            sql.SET("source_id = #{sourceId,jdbcType=BIGINT}");
        }
        
        if (record.getSourceOrderNo() != null) {
            sql.SET("source_order_no = #{sourceOrderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getSourceContent() != null) {
            sql.SET("source_content = #{sourceContent,jdbcType=VARCHAR}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{status,jdbcType=INTEGER}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getOpUserType() != null) {
            sql.SET("op_user_type = #{opUserType,jdbcType=INTEGER}");
        }
        
        if (record.getOpUserId() != null) {
            sql.SET("op_user_id = #{opUserId,jdbcType=BIGINT}");
        }
        
        if (record.getOpUserName() != null) {
            sql.SET("op_user_name = #{opUserName,jdbcType=VARCHAR}");
        }
        
        if (record.getOpUserPhone() != null) {
            sql.SET("op_user_phone = #{opUserPhone,jdbcType=VARCHAR}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{ext3,jdbcType=VARCHAR}");
        }
        
        sql.WHERE("id = #{id,jdbcType=BIGINT}");
        
        return sql.toString();
    }

    protected void applyWhere(SQL sql, BsUserIntegralRecordExample example, boolean includeExamplePhrase) {
        if (example == null) {
            return;
        }
        
        String parmPhrase1;
        String parmPhrase1_th;
        String parmPhrase2;
        String parmPhrase2_th;
        String parmPhrase3;
        String parmPhrase3_th;
        if (includeExamplePhrase) {
            parmPhrase1 = "%s #{example.oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{example.oredCriteria[%d].allCriteria[%d].value} and #{example.oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{example.oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{example.oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{example.oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        } else {
            parmPhrase1 = "%s #{oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{oredCriteria[%d].allCriteria[%d].value} and #{oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        }
        
        StringBuilder sb = new StringBuilder();
        List<Criteria> oredCriteria = example.getOredCriteria();
        boolean firstCriteria = true;
        for (int i = 0; i < oredCriteria.size(); i++) {
            Criteria criteria = oredCriteria.get(i);
            if (criteria.isValid()) {
                if (firstCriteria) {
                    firstCriteria = false;
                } else {
                    sb.append(" or ");
                }
                
                sb.append('(');
                List<Criterion> criterions = criteria.getAllCriteria();
                boolean firstCriterion = true;
                for (int j = 0; j < criterions.size(); j++) {
                    Criterion criterion = criterions.get(j);
                    if (firstCriterion) {
                        firstCriterion = false;
                    } else {
                        sb.append(" and ");
                    }
                    
                    if (criterion.isNoValue()) {
                        sb.append(criterion.getCondition());
                    } else if (criterion.isSingleValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase1, criterion.getCondition(), i, j));
                        } else {
                            sb.append(String.format(parmPhrase1_th, criterion.getCondition(), i, j,criterion.getTypeHandler()));
                        }
                    } else if (criterion.isBetweenValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase2, criterion.getCondition(), i, j, i, j));
                        } else {
                            sb.append(String.format(parmPhrase2_th, criterion.getCondition(), i, j, criterion.getTypeHandler(), i, j, criterion.getTypeHandler()));
                        }
                    } else if (criterion.isListValue()) {
                        sb.append(criterion.getCondition());
                        sb.append(" (");
                        List<?> listItems = (List<?>) criterion.getValue();
                        boolean comma = false;
                        for (int k = 0; k < listItems.size(); k++) {
                            if (comma) {
                                sb.append(", ");
                            } else {
                                comma = true;
                            }
                            if (criterion.getTypeHandler() == null) {
                                sb.append(String.format(parmPhrase3, i, j, k));
                            } else {
                                sb.append(String.format(parmPhrase3_th, i, j, k, criterion.getTypeHandler()));
                            }
                        }
                        sb.append(')');
                    }
                }
                sb.append(')');
            }
        }
        
        if (sb.length() > 0) {
            sql.WHERE(sb.toString());
        }
    }
}