package com.hfkj.dao;

import com.hfkj.entity.BsUser;
import com.hfkj.entity.BsUserExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface BsUserMapper extends BsUserMapperExt {
    @SelectProvider(type=BsUserSqlProvider.class, method="countByExample")
    long countByExample(BsUserExample example);

    @DeleteProvider(type=BsUserSqlProvider.class, method="deleteByExample")
    int deleteByExample(BsUserExample example);

    @Delete({
        "delete from bs_user",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into bs_user (head_img, `name`, ",
        "phone, `password`, ",
        "integral, `status`, ",
        "wx_mp_openid, wx_ma_openid, ",
        "create_time, update_time, ",
        "ext_1, ext_2, ext_3)",
        "values (#{headImg,jdbcType=VARCHAR}, #{name,jdbcType=VARCHAR}, ",
        "#{phone,jdbcType=VARCHAR}, #{password,jdbcType=VARCHAR}, ",
        "#{integral,jdbcType=BIGINT}, #{status,jdbcType=INTEGER}, ",
        "#{wxMpOpenid,jdbcType=VARCHAR}, #{wxMaOpenid,jdbcType=VARCHAR}, ",
        "#{createTime,jdbcType=TIMESTAMP}, #{updateTime,jdbcType=TIMESTAMP}, ",
        "#{ext1,jdbcType=VARCHAR}, #{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(BsUser record);

    @InsertProvider(type=BsUserSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(BsUser record);

    @SelectProvider(type=BsUserSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="head_img", property="headImg", jdbcType=JdbcType.VARCHAR),
        @Result(column="name", property="name", jdbcType=JdbcType.VARCHAR),
        @Result(column="phone", property="phone", jdbcType=JdbcType.VARCHAR),
        @Result(column="password", property="password", jdbcType=JdbcType.VARCHAR),
        @Result(column="integral", property="integral", jdbcType=JdbcType.BIGINT),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="wx_mp_openid", property="wxMpOpenid", jdbcType=JdbcType.VARCHAR),
        @Result(column="wx_ma_openid", property="wxMaOpenid", jdbcType=JdbcType.VARCHAR),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<BsUser> selectByExample(BsUserExample example);

    @Select({
        "select",
        "id, head_img, `name`, phone, `password`, integral, `status`, wx_mp_openid, wx_ma_openid, ",
        "create_time, update_time, ext_1, ext_2, ext_3",
        "from bs_user",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="head_img", property="headImg", jdbcType=JdbcType.VARCHAR),
        @Result(column="name", property="name", jdbcType=JdbcType.VARCHAR),
        @Result(column="phone", property="phone", jdbcType=JdbcType.VARCHAR),
        @Result(column="password", property="password", jdbcType=JdbcType.VARCHAR),
        @Result(column="integral", property="integral", jdbcType=JdbcType.BIGINT),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="wx_mp_openid", property="wxMpOpenid", jdbcType=JdbcType.VARCHAR),
        @Result(column="wx_ma_openid", property="wxMaOpenid", jdbcType=JdbcType.VARCHAR),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    BsUser selectByPrimaryKey(Long id);

    @UpdateProvider(type=BsUserSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") BsUser record, @Param("example") BsUserExample example);

    @UpdateProvider(type=BsUserSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") BsUser record, @Param("example") BsUserExample example);

    @UpdateProvider(type=BsUserSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(BsUser record);

    @Update({
        "update bs_user",
        "set head_img = #{headImg,jdbcType=VARCHAR},",
          "`name` = #{name,jdbcType=VARCHAR},",
          "phone = #{phone,jdbcType=VARCHAR},",
          "`password` = #{password,jdbcType=VARCHAR},",
          "integral = #{integral,jdbcType=BIGINT},",
          "`status` = #{status,jdbcType=INTEGER},",
          "wx_mp_openid = #{wxMpOpenid,jdbcType=VARCHAR},",
          "wx_ma_openid = #{wxMaOpenid,jdbcType=VARCHAR},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "update_time = #{updateTime,jdbcType=TIMESTAMP},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(BsUser record);
}