package com.hfkj.dao;

import com.hfkj.entity.CouponDiscount;
import com.hfkj.entity.CouponDiscountExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface CouponDiscountMapper extends CouponDiscountMapperExt {
    @SelectProvider(type=CouponDiscountSqlProvider.class, method="countByExample")
    long countByExample(CouponDiscountExample example);

    @DeleteProvider(type=CouponDiscountSqlProvider.class, method="deleteByExample")
    int deleteByExample(CouponDiscountExample example);

    @Delete({
        "delete from coupon_discount",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into coupon_discount (`name`, img, ",
        "`type`, `condition`, ",
        "price, percentage, ",
        "limit_num, effective_day, ",
        "effective_num, sales_end_time, ",
        "create_time, update_time, ",
        "op_id, op_name, `status`, ",
        "ext_1, ext_2, ext_3)",
        "values (#{name,jdbcType=VARCHAR}, #{img,jdbcType=VARCHAR}, ",
        "#{type,jdbcType=INTEGER}, #{condition,jdbcType=DECIMAL}, ",
        "#{price,jdbcType=DECIMAL}, #{percentage,jdbcType=DECIMAL}, ",
        "#{limitNum,jdbcType=INTEGER}, #{effectiveDay,jdbcType=INTEGER}, ",
        "#{effectiveNum,jdbcType=INTEGER}, #{salesEndTime,jdbcType=TIMESTAMP}, ",
        "#{createTime,jdbcType=TIMESTAMP}, #{updateTime,jdbcType=TIMESTAMP}, ",
        "#{opId,jdbcType=BIGINT}, #{opName,jdbcType=VARCHAR}, #{status,jdbcType=INTEGER}, ",
        "#{ext1,jdbcType=VARCHAR}, #{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(CouponDiscount record);

    @InsertProvider(type=CouponDiscountSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(CouponDiscount record);

    @SelectProvider(type=CouponDiscountSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="name", property="name", jdbcType=JdbcType.VARCHAR),
        @Result(column="img", property="img", jdbcType=JdbcType.VARCHAR),
        @Result(column="type", property="type", jdbcType=JdbcType.INTEGER),
        @Result(column="condition", property="condition", jdbcType=JdbcType.DECIMAL),
        @Result(column="price", property="price", jdbcType=JdbcType.DECIMAL),
        @Result(column="percentage", property="percentage", jdbcType=JdbcType.DECIMAL),
        @Result(column="limit_num", property="limitNum", jdbcType=JdbcType.INTEGER),
        @Result(column="effective_day", property="effectiveDay", jdbcType=JdbcType.INTEGER),
        @Result(column="effective_num", property="effectiveNum", jdbcType=JdbcType.INTEGER),
        @Result(column="sales_end_time", property="salesEndTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="op_id", property="opId", jdbcType=JdbcType.BIGINT),
        @Result(column="op_name", property="opName", jdbcType=JdbcType.VARCHAR),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<CouponDiscount> selectByExample(CouponDiscountExample example);

    @Select({
        "select",
        "id, `name`, img, `type`, `condition`, price, percentage, limit_num, effective_day, ",
        "effective_num, sales_end_time, create_time, update_time, op_id, op_name, `status`, ",
        "ext_1, ext_2, ext_3",
        "from coupon_discount",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="name", property="name", jdbcType=JdbcType.VARCHAR),
        @Result(column="img", property="img", jdbcType=JdbcType.VARCHAR),
        @Result(column="type", property="type", jdbcType=JdbcType.INTEGER),
        @Result(column="condition", property="condition", jdbcType=JdbcType.DECIMAL),
        @Result(column="price", property="price", jdbcType=JdbcType.DECIMAL),
        @Result(column="percentage", property="percentage", jdbcType=JdbcType.DECIMAL),
        @Result(column="limit_num", property="limitNum", jdbcType=JdbcType.INTEGER),
        @Result(column="effective_day", property="effectiveDay", jdbcType=JdbcType.INTEGER),
        @Result(column="effective_num", property="effectiveNum", jdbcType=JdbcType.INTEGER),
        @Result(column="sales_end_time", property="salesEndTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="op_id", property="opId", jdbcType=JdbcType.BIGINT),
        @Result(column="op_name", property="opName", jdbcType=JdbcType.VARCHAR),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    CouponDiscount selectByPrimaryKey(Long id);

    @UpdateProvider(type=CouponDiscountSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") CouponDiscount record, @Param("example") CouponDiscountExample example);

    @UpdateProvider(type=CouponDiscountSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") CouponDiscount record, @Param("example") CouponDiscountExample example);

    @UpdateProvider(type=CouponDiscountSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(CouponDiscount record);

    @Update({
        "update coupon_discount",
        "set `name` = #{name,jdbcType=VARCHAR},",
          "img = #{img,jdbcType=VARCHAR},",
          "`type` = #{type,jdbcType=INTEGER},",
          "`condition` = #{condition,jdbcType=DECIMAL},",
          "price = #{price,jdbcType=DECIMAL},",
          "percentage = #{percentage,jdbcType=DECIMAL},",
          "limit_num = #{limitNum,jdbcType=INTEGER},",
          "effective_day = #{effectiveDay,jdbcType=INTEGER},",
          "effective_num = #{effectiveNum,jdbcType=INTEGER},",
          "sales_end_time = #{salesEndTime,jdbcType=TIMESTAMP},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "update_time = #{updateTime,jdbcType=TIMESTAMP},",
          "op_id = #{opId,jdbcType=BIGINT},",
          "op_name = #{opName,jdbcType=VARCHAR},",
          "`status` = #{status,jdbcType=INTEGER},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(CouponDiscount record);
}