package com.hfkj.dao;

import com.hfkj.entity.GoodsSpecs;
import com.hfkj.entity.GoodsSpecsExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface GoodsSpecsMapper extends GoodsSpecsMapperExt {
    @SelectProvider(type=GoodsSpecsSqlProvider.class, method="countByExample")
    long countByExample(GoodsSpecsExample example);

    @DeleteProvider(type=GoodsSpecsSqlProvider.class, method="deleteByExample")
    int deleteByExample(GoodsSpecsExample example);

    @Delete({
        "delete from goods_specs",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into goods_specs (goods_id, `name`, ",
        "pur_limit, sale_price, ",
        "original_price, stock, ",
        "show_img, sales_end_time, ",
        "`status`, create_time, ",
        "update_time, ext_1, ",
        "ext_2, ext_3)",
        "values (#{goodsId,jdbcType=BIGINT}, #{name,jdbcType=VARCHAR}, ",
        "#{purLimit,jdbcType=INTEGER}, #{salePrice,jdbcType=DECIMAL}, ",
        "#{originalPrice,jdbcType=DECIMAL}, #{stock,jdbcType=INTEGER}, ",
        "#{showImg,jdbcType=VARCHAR}, #{salesEndTime,jdbcType=TIMESTAMP}, ",
        "#{status,jdbcType=INTEGER}, #{createTime,jdbcType=TIMESTAMP}, ",
        "#{updateTime,jdbcType=TIMESTAMP}, #{ext1,jdbcType=VARCHAR}, ",
        "#{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(GoodsSpecs record);

    @InsertProvider(type=GoodsSpecsSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(GoodsSpecs record);

    @SelectProvider(type=GoodsSpecsSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="goods_id", property="goodsId", jdbcType=JdbcType.BIGINT),
        @Result(column="name", property="name", jdbcType=JdbcType.VARCHAR),
        @Result(column="pur_limit", property="purLimit", jdbcType=JdbcType.INTEGER),
        @Result(column="sale_price", property="salePrice", jdbcType=JdbcType.DECIMAL),
        @Result(column="original_price", property="originalPrice", jdbcType=JdbcType.DECIMAL),
        @Result(column="stock", property="stock", jdbcType=JdbcType.INTEGER),
        @Result(column="show_img", property="showImg", jdbcType=JdbcType.VARCHAR),
        @Result(column="sales_end_time", property="salesEndTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<GoodsSpecs> selectByExample(GoodsSpecsExample example);

    @Select({
        "select",
        "id, goods_id, `name`, pur_limit, sale_price, original_price, stock, show_img, ",
        "sales_end_time, `status`, create_time, update_time, ext_1, ext_2, ext_3",
        "from goods_specs",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="goods_id", property="goodsId", jdbcType=JdbcType.BIGINT),
        @Result(column="name", property="name", jdbcType=JdbcType.VARCHAR),
        @Result(column="pur_limit", property="purLimit", jdbcType=JdbcType.INTEGER),
        @Result(column="sale_price", property="salePrice", jdbcType=JdbcType.DECIMAL),
        @Result(column="original_price", property="originalPrice", jdbcType=JdbcType.DECIMAL),
        @Result(column="stock", property="stock", jdbcType=JdbcType.INTEGER),
        @Result(column="show_img", property="showImg", jdbcType=JdbcType.VARCHAR),
        @Result(column="sales_end_time", property="salesEndTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    GoodsSpecs selectByPrimaryKey(Long id);

    @UpdateProvider(type=GoodsSpecsSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") GoodsSpecs record, @Param("example") GoodsSpecsExample example);

    @UpdateProvider(type=GoodsSpecsSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") GoodsSpecs record, @Param("example") GoodsSpecsExample example);

    @UpdateProvider(type=GoodsSpecsSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(GoodsSpecs record);

    @Update({
        "update goods_specs",
        "set goods_id = #{goodsId,jdbcType=BIGINT},",
          "`name` = #{name,jdbcType=VARCHAR},",
          "pur_limit = #{purLimit,jdbcType=INTEGER},",
          "sale_price = #{salePrice,jdbcType=DECIMAL},",
          "original_price = #{originalPrice,jdbcType=DECIMAL},",
          "stock = #{stock,jdbcType=INTEGER},",
          "show_img = #{showImg,jdbcType=VARCHAR},",
          "sales_end_time = #{salesEndTime,jdbcType=TIMESTAMP},",
          "`status` = #{status,jdbcType=INTEGER},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "update_time = #{updateTime,jdbcType=TIMESTAMP},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(GoodsSpecs record);
}
