package com.hfkj.dao;

import com.hfkj.entity.GoodsVpd;
import com.hfkj.entity.GoodsVpdExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface GoodsVpdMapper extends GoodsVpdMapperExt {
    @SelectProvider(type=GoodsVpdSqlProvider.class, method="countByExample")
    long countByExample(GoodsVpdExample example);

    @DeleteProvider(type=GoodsVpdSqlProvider.class, method="deleteByExample")
    int deleteByExample(GoodsVpdExample example);

    @Delete({
        "delete from goods_vpd",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into goods_vpd (specs_id, `key`, ",
        "valid_day, `type`, ",
        "`source`, jump_type, ",
        "sales_end_time, jump_url, ",
        "appid, create_time, ",
        "update_time, ext_1, ",
        "ext_2, ext_3)",
        "values (#{specsId,jdbcType=BIGINT}, #{key,jdbcType=VARCHAR}, ",
        "#{validDay,jdbcType=INTEGER}, #{type,jdbcType=INTEGER}, ",
        "#{source,jdbcType=INTEGER}, #{jumpType,jdbcType=INTEGER}, ",
        "#{salesEndTime,jdbcType=TIMESTAMP}, #{jumpUrl,jdbcType=VARCHAR}, ",
        "#{appid,jdbcType=VARCHAR}, #{createTime,jdbcType=TIMESTAMP}, ",
        "#{updateTime,jdbcType=TIMESTAMP}, #{ext1,jdbcType=VARCHAR}, ",
        "#{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(GoodsVpd record);

    @InsertProvider(type=GoodsVpdSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(GoodsVpd record);

    @SelectProvider(type=GoodsVpdSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="specs_id", property="specsId", jdbcType=JdbcType.BIGINT),
        @Result(column="key", property="key", jdbcType=JdbcType.VARCHAR),
        @Result(column="valid_day", property="validDay", jdbcType=JdbcType.INTEGER),
        @Result(column="type", property="type", jdbcType=JdbcType.INTEGER),
        @Result(column="source", property="source", jdbcType=JdbcType.INTEGER),
        @Result(column="jump_type", property="jumpType", jdbcType=JdbcType.INTEGER),
        @Result(column="sales_end_time", property="salesEndTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="jump_url", property="jumpUrl", jdbcType=JdbcType.VARCHAR),
        @Result(column="appid", property="appid", jdbcType=JdbcType.VARCHAR),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<GoodsVpd> selectByExample(GoodsVpdExample example);

    @Select({
        "select",
        "id, specs_id, `key`, valid_day, `type`, `source`, jump_type, sales_end_time, ",
        "jump_url, appid, create_time, update_time, ext_1, ext_2, ext_3",
        "from goods_vpd",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="specs_id", property="specsId", jdbcType=JdbcType.BIGINT),
        @Result(column="key", property="key", jdbcType=JdbcType.VARCHAR),
        @Result(column="valid_day", property="validDay", jdbcType=JdbcType.INTEGER),
        @Result(column="type", property="type", jdbcType=JdbcType.INTEGER),
        @Result(column="source", property="source", jdbcType=JdbcType.INTEGER),
        @Result(column="jump_type", property="jumpType", jdbcType=JdbcType.INTEGER),
        @Result(column="sales_end_time", property="salesEndTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="jump_url", property="jumpUrl", jdbcType=JdbcType.VARCHAR),
        @Result(column="appid", property="appid", jdbcType=JdbcType.VARCHAR),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    GoodsVpd selectByPrimaryKey(Long id);

    @UpdateProvider(type=GoodsVpdSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") GoodsVpd record, @Param("example") GoodsVpdExample example);

    @UpdateProvider(type=GoodsVpdSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") GoodsVpd record, @Param("example") GoodsVpdExample example);

    @UpdateProvider(type=GoodsVpdSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(GoodsVpd record);

    @Update({
        "update goods_vpd",
        "set specs_id = #{specsId,jdbcType=BIGINT},",
          "`key` = #{key,jdbcType=VARCHAR},",
          "valid_day = #{validDay,jdbcType=INTEGER},",
          "`type` = #{type,jdbcType=INTEGER},",
          "`source` = #{source,jdbcType=INTEGER},",
          "jump_type = #{jumpType,jdbcType=INTEGER},",
          "sales_end_time = #{salesEndTime,jdbcType=TIMESTAMP},",
          "jump_url = #{jumpUrl,jdbcType=VARCHAR},",
          "appid = #{appid,jdbcType=VARCHAR},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "update_time = #{updateTime,jdbcType=TIMESTAMP},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(GoodsVpd record);
}
