package com.hfkj.model;

import com.hfkj.entity.SecMenu;
import com.hfkj.entity.SecRole;
import com.hfkj.entity.SecUser;
import lombok.Data;

import java.util.List;

/**
 * 系统用户登录session对象
 */
@Data
public class SecUserSessionObject {

    /**
     * 登录账户
     */
    private SecUser account;

    /**
     * 角色信息
     */
    private SecRole role;

    /**
     * 菜单
     */
    private List<MenuTreeModel> menuTree;

    /**
     * 按钮
     */
    private List<SecMenu> button;

    public SecUserSessionObject(SecUser account, SecRole role, List<MenuTreeModel> menuTree, List<SecMenu> button){
        this.account = account;
        this.role = role;
        this.menuTree = menuTree;
        this.button = button;
    }

}
