package com.hfkj.service.goods;

import com.hfkj.entity.GoodsType;
import com.hfkj.model.goods.GoodsTypeModel;

import java.util.List;
import java.util.Map;

/**
 * @serviceName .java
 * @author Sum1Dream
 * @version 1.0.0
 * @Description // 商品类目管理
 * @createTime 15:07 2024/4/19
 **/
public interface GoodsTypeService {

    /**
    * @Author Sum1Dream
    * @Name create
    * @Description // 创建
    * @Date 15:11 2024/4/19
    * @Param goodsType
     * @return void
    */
    void create(GoodsType goodsType);

    /**
    * @Author Sum1Dream
    * @Name update
    * @Description // 修改
    * @Date 15:12 2024/4/19
    * @Param goodsType
     * @return void
    */
    void update(GoodsType goodsType);

    /**
    * @Author Sum1Dream
    * @Name delete
    * @Description // 修改
    * @Date 15:12 2024/4/19
    * @Param id
     * @return void
    */
    void delete(Long id , Boolean fullDelete);

    /**
    * @Author Sum1Dream
    * @Name queryDetail
    * @Description // 根据ID查询产品类型详情
    * @Date 15:12 2024/4/19
    * @Param id
     * @return com.hfkj.entity.GoodsType
    */
    GoodsType queryDetail(Long id);

    /**
    * @Author Sum1Dream
    * @Name queryDetailByMap
    * @Description // 根据多条件查询产品类型
    * @Date 15:12 2024/4/19
    * @Param map
     * @return com.hfkj.entity.GoodsType
    */
    GoodsType queryDetailByMap(Map<String , Object> map);

    /**
    * @Author Sum1Dream
    * @Name getList
    * @Description // 根据多条件查询列表
    * @Date 15:13 2024/4/19
    * @Param map
     * @return java.util.List<com.hfkj.entity.GoodsType>
    */
    List<GoodsType> getList(Map<String , Object> map);

    /**
     * @Author Sum1Dream
     * @Name getGoodsTypeModelList
     * @Description // 获取列表
     * @Date 15:13 2024/4/19
     * @Param map
     * @return java.util.List<com.hfkj.entity.GoodsType>
     */
    List<GoodsTypeModel> getGoodsTypeModelList(List<GoodsType> list);

    /**
     * @Author Sum1Dream
     * @Name findGoodsType
     * @Description // 获取列表
     * @Date 15:13 2024/4/19
     * @Param id
     * @return String
     */
    String findGoodsType(Long id);
}
