package com.hfkj.service.goods;

import com.hfkj.entity.GoodsVpd;

import java.util.List;
import java.util.Map;

/**
 * @serviceName .java
 * @author Sum1Dream
 * @version 1.0.0
 * @Description // 虚拟商品管理
 * @createTime 15:07 2024/4/19
 **/
public interface GoodsVpdService {


    /**
     * @Author Sum1Dream
     * @Name create
     * @Description // 创建
     * @Date 15:11 2024/4/19
     * @Param GoodsVpd
     * @return void
     */
    void create(GoodsVpd goodsVpd);

    /**
     * @Author Sum1Dream
     * @Name update
     * @Description // 修改
     * @Date 15:12 2024/4/19
     * @Param GoodsVpd
     * @return void
     */
    void update(GoodsVpd goodsVpd);

    /**
     * @Author Sum1Dream
     * @Name delete
     * @Description // 修改
     * @Date 15:12 2024/4/19
     * @Param id
     * @return void
     */
    void delete(Long id);

    /**
     * @Author Sum1Dream
     * @Name queryDetail
     * @Description // 根据ID查询产品类型详情
     * @Date 15:12 2024/4/19
     * @Param id
     * @return com.hfkj.entity.GoodsVpd
     */
    GoodsVpd queryDetail(Long id);

    /**
     * @Author Sum1Dream
     * @Name queryDetailBySpecsId
     * @Description // 根据多条件查询产品类型
     * @Date 15:12 2024/4/19
     * @Param map
     * @return com.hfkj.entity.GoodsVpd
     */
    void deleteSpecsId(Long specsId);

    GoodsVpd queryDetailBySpecsId(Long specsId);

    /**
     * @Author Sum1Dream
     * @Name getList
     * @Description // 根据多条件查询列表
     * @Date 15:13 2024/4/19
     * @Param map
     * @return java.util.List<com.hfkj.entity.GoodsVpd>
     */
    List<GoodsVpd> getList(Map<String , Object> map);
    
}
