package com.hfkj.service.goods.impl;

import com.hfkj.dao.GoodsSpecsMapper;
import com.hfkj.entity.GoodsMsg;
import com.hfkj.entity.GoodsSpecs;
import com.hfkj.entity.GoodsSpecsExample;
import com.hfkj.service.goods.GoodsSpecsService;
import com.hfkj.service.goods.GoodsVpdService;
import org.apache.commons.collections4.MapUtils;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.Date;
import java.util.List;
import java.util.Map;

@Service("goodsSpecsService")
public class GoodsSpecsServiceImpl implements GoodsSpecsService {

    @Resource
    private GoodsSpecsMapper goodsSpecsMapper;

    @Resource
    private GoodsVpdService goodsVpdService;


    @Override
    public void create(GoodsSpecs goodsSpecs) {
        goodsSpecsMapper.insert(goodsSpecs);
    }

    @Override
    public void update(GoodsSpecs goodsSpecs) {
        goodsSpecsMapper.updateByPrimaryKeySelective(goodsSpecs);
    }

    @Override
    public void delete(Long id, Boolean fullDelete) {
        if (fullDelete) {
            goodsSpecsMapper.deleteByPrimaryKey(id);
        } else {
            GoodsSpecs goodsSpecs = queryDetail(id);
            goodsSpecs.setStatus(0);
            goodsSpecs.setUpdateTime(new Date());
            update(goodsSpecs);
        }

        goodsVpdService.deleteSpecsId(id);

    }

    @Override
    public GoodsSpecs queryDetail(Long id) {
        return goodsSpecsMapper.selectByPrimaryKey(id);
    }

    @Override
    public GoodsSpecs queryDetailByGoodsId(Long id) {
        GoodsSpecsExample goodsSpecsExample = new GoodsSpecsExample();
        goodsSpecsExample.createCriteria().andGoodsIdEqualTo(id);

        List<GoodsSpecs> goodsSpecs = goodsSpecsMapper.selectByExample(goodsSpecsExample);

        if (!goodsSpecs.isEmpty()) {
            return goodsSpecs.get(0);
        }

        return null;
    }

    @Override
    public GoodsSpecs queryDetailByMap(Map<String, Object> map) {
        return null;
    }

    @Override
    public List<GoodsSpecs> getList(Map<String, Object> map) {

        GoodsSpecsExample goodsSpecsExample = new GoodsSpecsExample();
        GoodsSpecsExample.Criteria criteria = goodsSpecsExample.createCriteria();

        if (MapUtils.getLong(map, "goodsId") != null) {
            criteria.andGoodsIdEqualTo(MapUtils.getLong(map, "goodsId"));
        }
        criteria.andStatusNotEqualTo(0);


        return goodsSpecsMapper.selectByExample(goodsSpecsExample);
    }
}
